"XElement_AutoAPI.st Generated at 2018-09-22 00:05:09.736."
'Class AutoAPI file for Class Element.'!

!DocumentDictionary100.Core.Model.XElement class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XElement in the DomainModel DocumentDictionary100f"

	^'UML V1.4 compatible element. Works as abstract superclass for more specific model elements.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XElement'.!

 !

!DocumentDictionary100.Core.Model.XElement methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XElement in the DomainModel DocumentDictionary100f."

	^'UML V1.4 compatible element. Works as abstract superclass for more specific model elements.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitResourceId.



	
!
canDelete
	"Return true if this Element can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XElement if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	super delete!

 !

!DocumentDictionary100.Core.Model.XElement methodsFor: 'attributeAPI'!

attGetResourceId
	"Get value of attribute ResourceId"
	"A small unique integer within the domainmodel. Used for identifying resources associated with the element. For instance when generating help files and linked web reports."

	^attResourceId.!

attIqResourceId
	"Return the information quantity of attribute ResourceId"
	"180413 This is a default implementation that can be extended later"

	^attResourceId ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasResourceId
	"Return true if the current value of the attribute ResourceId carries information."

	^(attResourceId ~= nil)!

attCreateResourceId
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetResourceId: (0)!

attDeleteResourceId
	"Set the attribute value to undefined, or to a value that makes attIqResourceId return 0."

	^self attSetResourceId: nil!

attSetResourceId: value 
	"Set the value of attribute ResourceId to value, if it is not already equal to value."

	(attResourceId = value) ifFalse: [
		attResourceId := value.
		self changed: #attResourceId.
	]!

attInitResourceId
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetResourceId: (0)!

 !

!DocumentDictionary100.Core.Model.XElement methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XElement methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XElement methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XElement methodsFor: 'testing'!

classPrefix
	"Return 'EL' which is a unique prefix for class Element within the application."

	^'EL'!

 !

