"XProfileValue_AutoAPI.st Generated at 2018-09-22 00:07:35.772."
'Class AutoAPI file for Class ProfileValue.'!

!DocumentDictionary100.Core.Profile.XProfileValue class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfileValue in the DomainModel DocumentDictionary100f"

	^'Stores a value for an attribute that has been defined in a Profile. Has the same functionality as a tagged value in UML 1.4.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XProfileValue'.!

 !

!DocumentDictionary100.Core.Profile.XProfileValue methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XProfileValue in the DomainModel DocumentDictionary100f."

	^'Stores a value for an attribute that has been defined in a Profile. Has the same functionality as a tagged value in UML 1.4.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAttributeName.
	self attInitClassName.
	self attInitValue.


	self relInitModelElement.

	
!
canDelete
	"Return true if this ProfileValue can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XProfileValue if there is one, else return nil."

	self relHasModelElement ifTrue: [ ^self relGetModelElement ].

	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."



	self relRemoveAllModelElement.


	super delete!

 !

!DocumentDictionary100.Core.Profile.XProfileValue methodsFor: 'attributeAPI'!

attGetAttributeName
	"Get value of attribute AttributeName"
	"A name that indicates an extensible property to be attached to ModelElements."

	^attAttributeName.!

attGetClassName
	"Get value of attribute ClassName"
	"Class name to identify the class definition for this object instance."

	^attClassName.!

attGetValue
	"Get value of attribute Value"
	"An arbitrary value. The value must be expressible as a string for uniform manipulation. The range of permissible values depends on the interpretation applied to the tag by the user or tool; its specification is outside the scope of UML."

	^attValue.!

attIqAttributeName
	"Return the information quantity of attribute AttributeName"
	"180413 This is a default implementation that can be extended later"

	^attAttributeName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqClassName
	"Return the information quantity of attribute ClassName"
	"180413 This is a default implementation that can be extended later"

	^attClassName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqValue
	"Return the information quantity of attribute Value"
	"180413 This is a default implementation that can be extended later"

	^attValue ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAttributeName
	"Return true if the current value of the attribute AttributeName carries information."

	^(attAttributeName ~= nil)!

attHasClassName
	"Return true if the current value of the attribute ClassName carries information."

	^(attClassName ~= nil)!

attHasValue
	"Return true if the current value of the attribute Value carries information."

	^(attValue ~= nil)!

attCreateAttributeName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAttributeName: (nil)!

attCreateClassName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetClassName: (nil)!

attCreateValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetValue: (nil)!

attCreateAttributeName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAttributeName: (nil)!

attCreateClassName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetClassName: (nil)!

attCreateValue
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetValue: (nil)!

attDeleteAttributeName
	"Set the attribute value to undefined, or to a value that makes attIqAttributeName return 0."

	^self attSetAttributeName: nil!

attDeleteClassName
	"Set the attribute value to undefined, or to a value that makes attIqClassName return 0."

	^self attSetClassName: nil!

attDeleteValue
	"Set the attribute value to undefined, or to a value that makes attIqValue return 0."

	^self attSetValue: nil!

attSetAttributeName: value 
	"Set the value of attribute AttributeName to value, if it is not already equal to value."

	(attAttributeName = value) ifFalse: [
		attAttributeName := value.
		self changed: #attAttributeName.
	]!

attSetClassName: value 
	"Set the value of attribute ClassName to value, if it is not already equal to value."

	(attClassName = value) ifFalse: [
		attClassName := value.
		self changed: #attClassName.
	]!

attSetValue: value 
	"Set the value of attribute Value to value, if it is not already equal to value."

	(attValue = value) ifFalse: [
		attValue := value.
		self changed: #attValue.
	]!

attInitAttributeName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAttributeName := nil!

attInitClassName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attClassName := nil!

attInitValue
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attValue := nil!

 !

!DocumentDictionary100.Core.Profile.XProfileValue methodsFor: 'relationshipAPI'!

relRemoveAllModelElement
	"Remove a XModelElement from 1-N relationship2 ModelElement if there is one."
	"Helper method that is only called by other methods that maintain referential integrity and garbage collection themselves."

	(self relAllModelElement) do: [:ME1 | self relRemoveModelElement: ME1].!

relAllModelElement
	"Return collection of 1-N relationship modelElement"
	"Keeps compatibility with 1-N relationships"

	| coll |
	coll := OrderedCollection new.
	relModelElement ifNil: [ ^coll ].
	coll add: relModelElement.
	^coll.!

relSizeModelElement
	"Return the integer size of the collection returned by relAllModelElement"
	"Keeps compatibility with 1-N relationships"

	^relModelElement ifNil: [ 0 ] ifNotNil: [ 1 ].!

relHasModelElement
	"Return true if the 1-N relations2 modelElement holds an object, else return false."

	^relModelElement notNil.!

relCreateModelElement
	"2018-04-18 According to 30 years of practical programming experience after having gone through a Master of Computer Science Education, this variant will never be used by a well designed application."
	"The reason is that subordinate pop-up detail objects never create their own master. This variant might hovever appear in experimental algorithms exploiting the registry of chemical and biological inventions of BRAINLESS EVOLUTION."
	"Calling this method without a thought through framework above will leave danglig non-owned objects in the structure that are a notorious source of memory consumption garbage and failures to replicate an information state stored and retreived via a top-down serialization algorithm."
	"If you use this method in an application you need to create additional source code generator templates, or a superclass implementation of the method addDefaultOwner put in comments below, and uncomment that one."

	"Creates and adds a new XModelElement to 1-N relationship ModelElement."

	| ME1a ME1 |
	( ME1a := self relGetModelElement ) ifNotNil: [
		self dberror: 'XModelElement:relCreateModelElement: Error ' message: 
			'XModelElement (', self  asString , ') already has a XModelElement (', ME1a asString, ') in 1-N relation ModelElement.'.
		^nil.
	].
	((self getStorage) canStoreClass: DocumentDictionary100.Core.Profile.XModelElement) ifTrue: [
		ME1 := (self getStorage) createInstanceForClass: DocumentDictionary100.Core.Profile.XModelElement.
		ME1 relAddProfileValues: self.
		"ME1 addDefaultOwner."
		^ME1.
	] ifFalse: [
		self dberror: 'XProfileValue.relCreateModelElement Error' message:
			'Storage (', self getStorage asString, ') can not store DocumentDictionary100.Core.Profile.XModelElement. Please open an appropriate substorage first.'.
		^nil.
	].!

relGetModelElement
	"Return the XModelElement object on the other side of the 1-N relationship2 modelElement."

	^relModelElement!

relRemoveModelElement: ME1
	"Removes a XModelElement ME1 from 1-N relationship2 ModelElement."

	ME1 ifNil: [
		self dberror: 'XProfileValue:relRemoveModelElement: Error ' message: ( 'wrong class of parameter ME1, ',
			' nil is not a XModelElement, and can not be removed from' ,
			' this XProfileValue (', self asString, ') relation2 ModelElement.' ).
		^nil.
	].

	ME1 ifNotNil: [
		( ME1 isKindOf: DocumentDictionary100.Core.Model.XModelElement ) ifFalse: [
			self dberror: 'XProfileValue:relRemoveModelElement: Error ' message: ( ME1 asString ,
				' is not a XModelElement, and can not be removed from' ,
				' this XProfileValue (', self asString, ') relation2 ModelElement.' ).
			^nil.
		]
	].

	ME1 ifNotNil: [ ME1 relRemoveProfileValues: self. ].
	^ME1!

relInitModelElement
	"Initialize pointer of 1-N relationship1 ModelElement "

	relModelElement := nil!

 !

!DocumentDictionary100.Core.Profile.XProfileValue methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

relPrivateSetModelElement: ME1
	"Set other end of 1-N relationship1 ProfileValues"

	"ME1 isNil ifTrue: [ 
		Function point where you may delete a foreign key identifying ME1.
	]."

  "( ME1 isKindOf: NOT_FOUND.XModelElement ) ifFalse: [ This must have been checked by the public API method calling this private method ]." 

	( relModelElement == ME1 ) ifFalse: [
		relModelElement := ME1.
		ME1 ifNotNil: [ 
		  "Function point where you may set a foreign key identifying ME1."
	  ].
	  self changed: #relModelElement.
	].
	^relModelElement!

 !

!DocumentDictionary100.Core.Profile.XProfileValue methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Profile.XProfileValue methodsFor: 'testing'!

classPrefix
	"Return 'prpv' which is a unique prefix for class ProfileValue within the application."

	^'prpv'!

 !

