"XElementImport_AutoAPI.st Generated at 2018-09-22 00:05:11.871."
'Class AutoAPI file for Class ElementImport.'!

!DocumentDictionary100.Core.Model.XElementImport class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XElementImport in the DomainModel DocumentDictionary100f"

	^'Abstract superclass for external model elements that are imported into a model/package.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XElementImport'.!

 !

!DocumentDictionary100.Core.Model.XElementImport methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XElementImport in the DomainModel DocumentDictionary100f."

	^'Abstract superclass for external model elements that are imported into a model/package.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAlias.
	self attInitName.
	self attInitRemark.
	self attInitVisibility.



	
!
canDelete
	"Return true if this ElementImport can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XElementImport if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	super delete!

 !

!DocumentDictionary100.Core.Model.XElementImport methodsFor: 'attributeAPI'!

attGetAlias
	"Get value of attribute Alias"
	"An alias name used for the imported element within the package."

	^attAlias.!

attGetName
	"Get value of attribute Name"
	"A maximum 32-character English name for object which identifies the imported element."

	^attName.!

attGetRemark
	"Get value of attribute Remark"
	"Any comment about the import of this element."

	^attRemark.!

attGetVisibility
	"Get value of attribute Visibility"
	"May be any of private, protected or public."

	^attVisibility.!

attIqAlias
	"Return the information quantity of attribute Alias"
	"180413 This is a default implementation that can be extended later"

	^attAlias ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqName
	"Return the information quantity of attribute Name"
	"180413 This is a default implementation that can be extended later"

	^attName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqRemark
	"Return the information quantity of attribute Remark"
	"180413 This is a default implementation that can be extended later"

	^attRemark ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqVisibility
	"Return the information quantity of attribute Visibility"
	"180413 This is a default implementation that can be extended later"

	^attVisibility ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAlias
	"Return true if the current value of the attribute Alias carries information."

	^(attAlias ~= nil)!

attHasName
	"Return true if the current value of the attribute Name carries information."

	^(attName ~= nil)!

attHasRemark
	"Return true if the current value of the attribute Remark carries information."

	^(attRemark ~= nil)!

attHasVisibility
	"Return true if the current value of the attribute Visibility carries information."

	^(attVisibility ~= nil)!

attCreateAlias
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAlias: (nil)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetName: (nil)!

attCreateRemark
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetRemark: (nil)!

attCreateVisibility
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetVisibility: (nil)!

attCreateAlias
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAlias: (nil)!

attCreateName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetName: (nil)!

attCreateRemark
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetRemark: (nil)!

attCreateVisibility
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetVisibility: (nil)!

attDeleteAlias
	"Set the attribute value to undefined, or to a value that makes attIqAlias return 0."

	^self attSetAlias: nil!

attDeleteName
	"Set the attribute value to undefined, or to a value that makes attIqName return 0."

	^self attSetName: nil!

attDeleteRemark
	"Set the attribute value to undefined, or to a value that makes attIqRemark return 0."

	^self attSetRemark: nil!

attDeleteVisibility
	"Set the attribute value to undefined, or to a value that makes attIqVisibility return 0."

	^self attSetVisibility: nil!

attSetAlias: value 
	"Set the value of attribute Alias to value, if it is not already equal to value."

	(attAlias = value) ifFalse: [
		attAlias := value.
		self changed: #attAlias.
	]!

attSetName: value 
	"Set the value of attribute Name to value, if it is not already equal to value."

	(attName = value) ifFalse: [
		attName := value.
		self changed: #attName.
	]!

attSetRemark: value 
	"Set the value of attribute Remark to value, if it is not already equal to value."

	(attRemark = value) ifFalse: [
		attRemark := value.
		self changed: #attRemark.
	]!

attSetVisibility: value 
	"Set the value of attribute Visibility to value, if it is not already equal to value."

	(attVisibility = value) ifFalse: [
		attVisibility := value.
		self changed: #attVisibility.
	]!

attInitAlias
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAlias := nil!

attInitName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attName := nil!

attInitRemark
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attRemark := nil!

attInitVisibility
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attVisibility := nil!

 !

!DocumentDictionary100.Core.Model.XElementImport methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XElementImport methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XElementImport methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XElementImport methodsFor: 'testing'!

classPrefix
	"Return 'EI' which is a unique prefix for class ElementImport within the application."

	^'EI'!

 !

