"XObject_AutoAPI.st Generated at 2018-09-22 00:06:32.901."
'Class AutoAPI file for Class Object.'!

!DocumentDictionary100.Core.Model.XObject class methodsFor: 'autoAPI'!

helpDefinition
	"The class autoAPI is implemented by root classes, but can optionally be overridden manually in subclass classes."
	"This method is here to fill the autoAPI protocol and returns the definition of class XObject in the DomainModel DocumentDictionary100f"

	^'Defines a standard set of documentation and administration attributes that are inherited by information model objects that are important for the modeled domain.'.!

helpClassName
	"Returns the name of this class for help text messages to the user."

	^'XObject'.!

 !

!DocumentDictionary100.Core.Model.XObject methodsFor: 'autoAPI'!

helpDefinition
	"The autoAPI is implemented by root classes, but can optionally be overridden manually in subclasses."
	"This method is here to fill the autoAPI protocol and returns the definition of class XObject in the DomainModel DocumentDictionary100f."

	^'Defines a standard set of documentation and administration attributes that are inherited by information model objects that are important for the modeled domain.'.!

initialize
	"initialize attributes and relationships"

	super initialize.
	self attInitAltDefinition.
	self attInitAltName.
	self attInitAltShortName.
	self attInitAuxDefinition.
	self attInitAuxName.
	self attInitCodeGenData.
	self attInitLabel.
	self attInitShortName.



	
!
canDelete
	"Return true if this Object can be deleted without violating cardinality constraints."

	(super canDelete) ifFalse: [^false].


	^true!

getOwner
	"Return owner of this XObject if there is one, else return nil."


	^nil!

delete
	"Delete the object and all objects in its owned part-of relationships, while maintaining referential integrity."





	super delete!

 !

!DocumentDictionary100.Core.Model.XObject methodsFor: 'attributeAPI'!

attGetAltDefinition
	"Get value of attribute AltDefinition"
	"Short alternate definition for this object in the same language as altname. Recommended to be less than 160 characters."

	^attAltDefinition.!

attGetAltName
	"Get value of attribute AltName"
	"A max 32-character alternate name for the object. Usually a swedish name."

	^attAltName.!

attGetAltShortName
	"Get value of attribute AltShortName"
	"An alternate max 8-character long name for object. altShortName is only specified when there is a need to define unique backward compatible names, such as for applications running on legacy database- and file systems."

	^attAltShortName.!

attGetAuxDefinition
	"Get value of attribute AuxDefinition"
	"Short auxilliary definition for this object in the same language as auxname. Recommended to be less than 160 characters."

	^attAuxDefinition.!

attGetAuxName
	"Get value of attribute AuxName"
	"A max 32-character auxilliary name for the object. Usually a german name."

	^attAuxName.!

attGetCodeGenData
	"Get value of attribute CodeGenData"
	"Holds various generated symbolic abbreviations used for code generation."

	^attCodeGenData.!

attGetLabel
	"Get value of attribute Label"
	"A number or character string used for shorthand identification and ordering of objects on the same level in their main hierarchy. The position in the hierarchy can be represented by a hierarchy path of object.labels (example 1.2.1.4)."

	^attLabel.!

attGetShortName
	"Get value of attribute ShortName"
	"A max 18-character english short name for object. shortName holds usually the same value as name, but may differ when the natural name is larger than 18 characters."

	^attShortName.!

attIqAltDefinition
	"Return the information quantity of attribute AltDefinition"
	"180413 This is a default implementation that can be extended later"

	^attAltDefinition ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqAltName
	"Return the information quantity of attribute AltName"
	"180413 This is a default implementation that can be extended later"

	^attAltName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqAltShortName
	"Return the information quantity of attribute AltShortName"
	"180413 This is a default implementation that can be extended later"

	^attAltShortName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqAuxDefinition
	"Return the information quantity of attribute AuxDefinition"
	"180413 This is a default implementation that can be extended later"

	^attAuxDefinition ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqAuxName
	"Return the information quantity of attribute AuxName"
	"180413 This is a default implementation that can be extended later"

	^attAuxName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqCodeGenData
	"Return the information quantity of attribute CodeGenData"
	"180413 This is a default implementation that can be extended later"

	^attCodeGenData ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqLabel
	"Return the information quantity of attribute Label"
	"180413 This is a default implementation that can be extended later"

	^attLabel ifNil: [ 0 ] ifNotNil: [ 1 ].!

attIqShortName
	"Return the information quantity of attribute ShortName"
	"180413 This is a default implementation that can be extended later"

	^attShortName ifNil: [ 0 ] ifNotNil: [ 1 ].!

attHasAltDefinition
	"Return true if the current value of the attribute AltDefinition carries information."

	^(attAltDefinition ~= nil)!

attHasAltName
	"Return true if the current value of the attribute AltName carries information."

	^(attAltName ~= nil)!

attHasAltShortName
	"Return true if the current value of the attribute AltShortName carries information."

	^(attAltShortName ~= nil)!

attHasAuxDefinition
	"Return true if the current value of the attribute AuxDefinition carries information."

	^(attAuxDefinition ~= nil)!

attHasAuxName
	"Return true if the current value of the attribute AuxName carries information."

	^(attAuxName ~= nil)!

attHasCodeGenData
	"Return true if the current value of the attribute CodeGenData carries information."

	^(attCodeGenData ~= nil)!

attHasLabel
	"Return true if the current value of the attribute Label carries information."

	^(attLabel ~= nil)!

attHasShortName
	"Return true if the current value of the attribute ShortName carries information."

	^(attShortName ~= nil)!

attCreateAltDefinition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAltDefinition: (nil)!

attCreateAltName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAltName: (nil)!

attCreateAltShortName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAltShortName: (nil)!

attCreateAuxName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetAuxName: (nil)!

attCreateLabel
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetLabel: (nil)!

attCreateShortName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 446 [o.attCreate_2] "

	^self attSetShortName: (nil)!

attCreateAltDefinition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAltDefinition: (nil)!

attCreateAltName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAltName: (nil)!

attCreateAltShortName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAltShortName: (nil)!

attCreateAuxDefinition
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAuxDefinition: (String new: 32767)!

attCreateAuxName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetAuxName: (nil)!

attCreateCodeGenData
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetCodeGenData: (String new: 32)!

attCreateLabel
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetLabel: (nil)!

attCreateShortName
	"Set the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 460 [o.attCreate_3] "

	^self attSetShortName: (nil)!

attDeleteAltDefinition
	"Set the attribute value to undefined, or to a value that makes attIqAltDefinition return 0."

	^self attSetAltDefinition: nil!

attDeleteAltName
	"Set the attribute value to undefined, or to a value that makes attIqAltName return 0."

	^self attSetAltName: nil!

attDeleteAltShortName
	"Set the attribute value to undefined, or to a value that makes attIqAltShortName return 0."

	^self attSetAltShortName: nil!

attDeleteAuxDefinition
	"Set the attribute value to undefined, or to a value that makes attIqAuxDefinition return 0."

	^self attSetAuxDefinition: nil!

attDeleteAuxName
	"Set the attribute value to undefined, or to a value that makes attIqAuxName return 0."

	^self attSetAuxName: nil!

attDeleteCodeGenData
	"Set the attribute value to undefined, or to a value that makes attIqCodeGenData return 0."

	^self attSetCodeGenData: nil!

attDeleteLabel
	"Set the attribute value to undefined, or to a value that makes attIqLabel return 0."

	^self attSetLabel: nil!

attDeleteShortName
	"Set the attribute value to undefined, or to a value that makes attIqShortName return 0."

	^self attSetShortName: nil!

attSetAltDefinition: value 
	"Set the value of attribute AltDefinition to value, if it is not already equal to value."

	(attAltDefinition = value) ifFalse: [
		attAltDefinition := value.
		self changed: #attAltDefinition.
	]!

attSetAltName: value 
	"Set the value of attribute AltName to value, if it is not already equal to value."

	(attAltName = value) ifFalse: [
		attAltName := value.
		self changed: #attAltName.
	]!

attSetAltShortName: value 
	"Set the value of attribute AltShortName to value, if it is not already equal to value."

	(attAltShortName = value) ifFalse: [
		attAltShortName := value.
		self changed: #attAltShortName.
	]!

attSetAuxDefinition: value 
	"Set the value of attribute AuxDefinition to value, if it is not already equal to value."

	(attAuxDefinition = value) ifFalse: [
		attAuxDefinition := value.
		self changed: #attAuxDefinition.
	]!

attSetAuxName: value 
	"Set the value of attribute AuxName to value, if it is not already equal to value."

	(attAuxName = value) ifFalse: [
		attAuxName := value.
		self changed: #attAuxName.
	]!

attSetCodeGenData: value 
	"Set the value of attribute CodeGenData to value, if it is not already equal to value."

	(attCodeGenData = value) ifFalse: [
		attCodeGenData := value.
		self changed: #attCodeGenData.
	]!

attSetLabel: value 
	"Set the value of attribute Label to value, if it is not already equal to value."

	(attLabel = value) ifFalse: [
		attLabel := value.
		self changed: #attLabel.
	]!

attSetShortName: value 
	"Set the value of attribute ShortName to value, if it is not already equal to value."

	(attShortName = value) ifFalse: [
		attShortName := value.
		self changed: #attShortName.
	]!

attInitAltDefinition
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAltDefinition := nil!

attInitAltName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAltName := nil!

attInitAltShortName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAltShortName := nil!

attInitAuxName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attAuxName := nil!

attInitLabel
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attLabel := nil!

attInitShortName
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 501 [o.attInit_1] "

	attShortName := nil!

attInitAuxDefinition
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetAuxDefinition: (String new: 32767)!

attInitCodeGenData
	"Initialize the attribute value to the default value specified in the domain model."
	
	"SOURCE CODE GENERATION RULE: 531 [o.attInit_3] "

	self attSetCodeGenData: (String new: 32)!

 !

!DocumentDictionary100.Core.Model.XObject methodsFor: 'relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XObject methodsFor: 'privateRelationshipAPI'!

helpPrivateRelationshipAPIDefinition
	"Just to fill in this protocol, if there are no relationships."
	^'The protocol privateRelationshipAPI contains private support methods for the public relationshipAPI'!

 !

!DocumentDictionary100.Core.Model.XObject methodsFor: 'converting'!

 !

!DocumentDictionary100.Core.Model.XObject methodsFor: 'testing'!

classPrefix
	"Return 'OB' which is a unique prefix for class Object within the application."

	^'OB'!

 !

