"XCategoryLink.st Generated at 2018-09-22 00:00:23.525."
'Class Declaration for Class CategoryLink.'!

DocumentDictionary100.Main defineClass: #XCategoryLink
	superclass: #{DocumentDictionary100.Main.XLabelModelElement}
	indexedType: #none
	private: false
	instanceVariableNames: '
		attCategoryRole
		
		relCategory
		relModelElement
  '
	classInstanceVariableNames: ''
	imports: ''
	category: 'AutoDomain'!
 
DocumentDictionary100.Main.XCategoryLink comment: 
'Links a ModelElement to a Category.
The link should prefferably cache the Name and Definition of the linked memberOfCategories ModelElement, for the sake of filtered loading from large or huge repositories, to allow the user of a local copy created from a filtered model load, quick access to metadata of the components that are missing in the loaded model.
The information in the cached attributes of a link should be treated for the caches they are, thus repository implementations may chose to trigger updates of changes in ModelElement Name and Definition to the cached data in their memberOfCategories CategoryLink objects.
This this will allow filter syncronizing users to get updates on the latest changes at the next time of synchronization. 

'!
